#!/usr/bin/perl -w
#
# Written by David Allen s2mdalle@titan.vcu.edu 
# http://opop.nols.com/
# On a boring day.  :)
#
# This was originally written with the "banner" program in mind, but 
# has now been hacked for 'simplefont'
#
# Released under the GNU GPL.
#
# Usage:  bxpm.pl FILENAME "Message to be printed" (rv)
# The rv flag is not needed if you don't want it.  It just flips the 
# foreground/background colors if it is specified.
############################################################################

use strict;

my $out = shift;
my $PATH_TO_BANNER="./";

my $message = shift;
my $rv = shift;

if((not $out) or  (not $message))
{
    usage();
    exit(0);
}

open (OUT, ">$out") or die "Couldn't do that man. $!\n";

my $cmd = "$PATH_TO_BANNER/simplefont -q "."\"$message\"";

print "Calling $cmd\n";
my $foobar = `$cmd`;

my @foo = split /\n/, $foobar;

my $max = 0;

foreach my $temp (@foo)
{
    $max = length($temp) if (length($temp)>$max);
}

# Bump up the string length of every line in the output.
for(my $x=0; $x<$#foo; $x++)
{
    # Get everybody up to the right string count.
    # Otherwise the xpm gets all screwed up.  Trust me it sucks.
    $foo[$x] =~ s/\#/O/g;
    while(length($foo[$x])<$max)
    {
	$foo[$x] = $foo[$x]. " ";       # Append one blank space.
    } # End while
} # End for.

# File header
print OUT xpm_header($max, $#foo, $rv);

print "I'm creating an image that has $max rows, $#foo cols.\n";
if($rv)
{
    print "The picture has reverse video on.\n";
}

foreach my $temp (@foo)
{
    print OUT "\"$temp\",\n";
}

print OUT "};\n";
close OUT;

###########################################################################

sub xpm_header
{
    my $width = shift;
    my $lines = shift;
    my $colors = shift;

    my ($fg, $bg);
    my $rv = shift;

    if($rv)                   # There was an arg.
    {
	$fg = "#FFFFFF";
	$bg = "#000000";
    }
    else
    {
	$fg = "#000000";
	$bg = "#FFFFFF";
    }

    if(not $colors)
    {
	$colors=2;
    }
    my $foo = "/* XPM */\n".
	"static char * foobar_xpm[] = {\n".
	    "\"$width $lines $colors 1\",\n".
		"\"*       c ".$fg."\",\n".
		    "\"        c ".$bg."\",\n";
    return $foo;
}

#############################################################################

sub usage{
    print STDERR "********************************************************\n";
    print STDERR "Usage:  Call the program with two arguments - the first \n";
    print STDERR "should be the name of the file you want to output to, and\n";
    print STDERR "the second should be the message you want in the xpm.\n";
    print STDERR "If you give a third argument of \"rv\" then the banner \n";
    print STDERR "will be printed to the xpm reversed color.  (Black and \n";
    print STDERR "white instead of white and black)\n";
    print STDERR "\nWritten by David Allen, s2mdalle\@titan.vcu.edu\n";
    print STDERR "http://opop.nols.com/          -- GNU Software Rocks.\n";
    print STDERR "********************************************************\n";
    exit(0);
}

#############################################################################

# EOF



